var app = require('express')()
var http = require('http').Server(app)
var io = require('socket.io')(http)
var request = require('request')

var url,pagina, llave,lock=false;

app.get('/', function (req, res) {
  res.sendFile(__dirname +'/pastodel.html')
})

io.on('connection', function(socket){
  socket.on('mensaje', function(msg) {
    url = msg.url
    pagina = Number(msg.page)
    llave = msg.key
    if (!lock){
      io.emit('chat', 'Extrayendo Información de: '+ url)
      lock = true;
      paginacion()
    } else {
      io.emit('chat', 'Se está realizando un trabajo actualmente, no molestes!')
    }
  })
});

function comprobarimg(obj, i) {
  if (obj.length > i){
    io.emit('chat','Comprobando: '+obj[i].id)
    request(obj[i].img, (error, response)=> {
      if (response.statusCode === 200){
        io.emit('chat', obj[i].id+' existe!')
        i=i+1;
        comprobarimg(obj,i)
      } else if (response.statusCode === 404){
        io.emit('chat', obj[i].id+' no existe! ejecutando borrado...')
        request(url+'wp-admin/admin-ajax.php?action=kj_pastodelapi&key='+llave+'&pid='+obj[i].id, (error, response, body)=> {
          if (response.statusCode === 200){
            io.emit('chat', body)
          } else {
            io.emit('chat', 'Se perdió la conexión al intentar eliminar '+obj[i].id)
          }
          i=i+1;
          comprobarimg(obj,i)
        })
      }
      io.emit('page', pagina)
    })
  } else {
    pagina = pagina + 1
    paginacion()
  }
}

function paginacion() {
  request(url+'wp-admin/admin-ajax.php?action=kj_pastodelapi&key='+llave+'&p='+pagina, (error, response, body)=> {
    if (!error && response.statusCode === 200) {
      if (body == "[]"){
        lock = false
        io.emit('chat','Trabajo finalizado!')
        return
      }
      var objetos = JSON.parse(body)
      comprobarimg(objetos,0)
    } else {
      lock = false
      console.log(JSON.stringify(error));
      //io.emit('chat',"Error: "+error+", status code: "+response.statusCode)
    }
  })
}

http.listen(8081)
